#pragma once

#include <string>
#include <vector>
#include <memory>
#include <cpptoml.h>

#include "shaders.h"
#include "pipeline/post.h"

class Scene {
public:
	std::string name;

	ShaderBundle::ProgramHandle* shader_p;

	PostConfig postConfig;
};

class NullScene : public Scene {
};

class Project {
public:
	Project() = default;

	static std::unique_ptr<Project> fromFile(std::string path);
	static std::unique_ptr<Project> fromToml(std::shared_ptr<cpptoml::table> manifest, filesystem::path basepath);

	void load_scene(std::shared_ptr<Scene> scene);


	std::vector<std::shared_ptr<Scene>> scenes;
	std::shared_ptr<Scene> current_scene;
	bool scene_loaded = false;
	std::string name;

    std::shared_ptr<ShaderBundle> shader_bundle;
};